/***************************************************************************


   Plik latex.s

   Plik latex.s zawiera makro `, Alt ` i Alt h oraz opis archiwum 4tse.zip

   Makro ` wspolpracuje z programem TSE i wraz z plikiem slatex wspomaga
   edycje dokumentow pisanych w formacie LaTeX 2.09.

   Makro Alt ` wypisuje znak `.

   Makro Alt h wyswietla spis kluczy wraz z odpowiadajacymi im
   rozwinieciami.


   Plik slatex

   Plik slatex zawiera klucze dla makro ` oraz ich rozwiniecia.

   Lewa kolumna pliku slatex sklada sie z kluczy, ktore wywoluja polecenia,
   parametry itp. z prawej kolumny.

   Kolumna kluczy zaczyna sie w pierwszej kolumnie pliku slatex, kolumna
   polecen i parametrow w dziewiatej kolumnie pliku.

   Klucz moze sie skladac wylacznie ze znakow alfanumerycznych i nie moze
   byc dluzszy niz osmioznakowy.

   Litery duze i male sa rozrozniane.


   Konfiguracja standardowa

   1. Umiescic pliki z archiwum 4tse.zip w katalogu z programem TSE.

   2. Wczytac plik latex.s do programu TSE.

   3. Sciezke dostepu w lancuchu sLaTeX zmienic zgodnie z przyjeta
      lokalizacja pliku slatex (p. linia 160 niniejszego pliku):

      string sLaTeX[] = "f:\bin\tse\slatex"

   4. Jezeli edytor zostal przekonfigurowany tak, ze linia stanu znajduje
      sie u dolu ekranu, nalezy dokonac zamiany pary znakow // (DEC 47) na
      pare znakow "" (DEC 34) w liniach powyzej 200, w niniejszym pliku.

   5. Skompilowac makro latex.s:

      ESC m c ESC

   6. Wywolac opcje AutoLoad List:

      ESC m a

      Nacisnac klawisz INS i napisac:

      latex

      Nacisnac klawisze ENTER i ESC.


   Konfiguracja alternatywna

   1--5, jak wyzej.

   6. Wywolac makro Potpourri:

      ESC u u

      Nacisnac klawisz INS i napisac:

      LaTeX

      Nacisnac klawisz ENTER i napisac:

      Expands keys to LaTeX 2.09 parameters, and commands.

      Keys:
            `        Expands a key to LaTeX 2.09 command.
            Alt `    Writes ` (DEC 96).
            Alt h    Displays LaTeX Help.

      Nacisnac klawisze ESC, E, ESC.


   Uzycie makro `

   Po skonfigurowaniu standardowym, makro ` wczytuje sie automatycznie na
   poczatku kazdej nowej sesji; po skonfigurowaniu alternatywnym, nalezy
   przed uzyciem wczytac je za posrednictwem makro Potpourri:

   ESC u u latex ENTER

   Pojedynczy przebieg makro ` obejmuje wypisanie wybranego klucza i
   nacisniecie klawisza `, powodujace rozwiniecie klucza do postaci
   polecenia lub parametru.

   Po zakonczeniu przebiegu makro, kursor ustawia sie tuz za wpisanym
   poleceniem lub parametrem, o ile nie wystepuje w nim sekwencja znakow ""
   (polecenie \verb"") lub puste nawiasy: [], () albo {}. W tym drugim
   wypadku, kursor ustawia sie w obrebie cudzyslowu lub nawiasu.

   Sekwencje znakow niewystepujace w pliku slatex jako klucze sa zaznaczane
   blokiem ulatwiajacym ich usuniecie z edytowanego pliku.


   Przyklad

   Najprostszy dokument w formacie LaTeX 2.09 ma postac:

      \documentstyle[a4]{article}
      \begin{document}
      _
      \end{document}

   Z pomoca makro ` i pliku slatex mozna go uzyskac naciskajac kolejno:

      dsa` ENTER bgdc` ENTER ENTER eddc` HOME CURSORUP

   Przy tradycyjnej edycji uzyskanie tego dokumentu wymaga nacisniecia 68
   klawiszy, w tym jedenastokrotnie znakow specjalnych i szesciokrotnie
   klawisza SHIFT.

   Przy edycji wspomaganej przez makro ` uzyskanie tego dokumentu wymaga
   nacisniecia 19 klawiszy, w tym trzykrotnie klawisza `.

   Powyzszy dokument mozna tez uzyskac wywolujac poszczegolne klucze
   sekwencyjnie:

      ds` aa` END ENTER bg` dc` END ENTER ENTER ed` dc` HOME CURSORUP


   TeX i LaTeX2e

   Majac za wzor plik slatex, latwo jest utworzyc pliki wspomagajace edycje
   dokumentow pisanych w formacie TeX lub LaTeX2e.


   Licencja

   Archiwum 4tse.zip jest dobrem wspolnym (public domain) i nie ma zadnej
   gwarancji.

   Pliki z archiwum 4tse.zip mozna przystosowywac do wlasnych potrzeb, ale
   zabrania sie rozprowadzania ich w wersji innej niz oryginalna.


   Autor

   Cezary M. Kruk
   ul. Zielonogorska 7 m. 2
   53-617 Wroclaw
   (0-71) 55 67 94


***************************************************************************/


string sLaTeX[] = "f:\bin\tse\slatex"

proc TheEnd()
    Right() UnMarkBlock()
    end

proc Stop()
    AbandonFile()
    MarkWord() lFind("","") DelChar()
    end

proc Cont2()
    MarkChar() EndLine() MarkChar() Copy()
    AbandonFile()
    MarkWord() DelBlock()
    Paste() MarkChar() lFind("","") DelChar() MarkChar() GotoBlockBegin()
    if lFind('"',"l") TheEnd() endif
    if lFind("[]","l") TheEnd() endif
    if lFind("()","l") TheEnd() endif
    if lFind("{}","l") TheEnd() endif
    GotoBlockEnd() UnMarkBlock()
    end

proc Cont1()
    GotoColumn(9)
    if CurrChar() < 0 Stop() else Cont2() endif
    end

proc LaTeX()
    string Key[8] = ""
    UnMarkBlock() InsertText("") Left() Left()
    MarkWord() GotoBlockBegin() Key=GetMarkedText() Copy()
    EditFile(sLaTeX) BegFile()
    if not lFind(Key,"^w") Stop() else Cont1() endif
    end

proc Alias()
    InsertText("`")
    end

helpdef LaTeXHelp
    title = "LaTeX Help"
    //
    "   bg    \begin{}         ed    \end{}           ds    \documentstyle[a4]{}   "
    " "
    "   11    11pt,            fg    figure*          mhd   myheadings             "
    "   12    12pt,            fq    fleqn,           ob    openbib                "
    "   abs   abstract         flt   flushleft        pc    picture                "
    "   Ap    Alph             frg   flushright       pl    plain                  "
    "   ap    alph             fs    footskip         qtn   quotation              "
    "   ab    arabic           hd    headings         qt    quote                  "
    "   ar    array            ia    iarticle         rr    report                 "
    "   aa    article          ib    ibook            ss    slides                 "
    "   bz    bezier,          il    iletter          slpp  sloppypar              "
    "   bb    book             ir    ireport          tg    tabbing                "
    "   cn    center           imz   itemize          tbl   table*                 "
    "   dsc   description      ittlp ititlepa         tblr  tabular*               "
    "   dmh   displaymath      ittp  ititlepa         thm   theorem                "
    "   dc    document         lq    leqno,           ttlp  titlepage              "
    "   dr    draft,           ll    letter           ttp   titlepage              "
    "   ep    empty            ltr   letter           2c    twocolumn,             "
    "   en    enumerate        ls    list             2s    twoside,               "
    "   ear   eqnarray*        mh    math             vbm   verbatim               "
    "   eq    equation         mnp   minipage         vr    verse                  "
    //
    "                                    A -- C                                    "
    " "
    "   acl     \addcontentsline{}{}{}        bbg     \bibliography{}              "
    "   ad      \address{}                    bsk     \bigskip                     "
    "   ac      \addtocontents{}{}            bska    \bigskipamount               "
    "   acr     \addtocounter{}{}             bmh     \boldmath                    "
    "   alg     \addtolength{}{}              btf     \bottomfraction              "
    "   aph     \alph{}                       ct      \caption[]{}                 "
    "   ax      \appendix                     cc      \cc{}                        "
    "   arb     \arabic{}                     cng     \centering                   "
    "   arcs    \arraycolsep                  ch      \chapter*[]{}                "
    "   arrw    \arrayrulewidth               ccl     \circle*{}                   "
    "   arst    \arraystretch                 ci      \cite[]{}                    "
    "   at      \author{}                     cd      \cleardoublepage             "
    "   bs      \backslash                    cp      \clearpage                   "
    "   blsk    \baselineskip                 cl      \cline{}                     "
    "   blst    \baselinestretch              cg      \closing{}                   "
    "   bg      \begin{}                      cls     \columnsep                   "
    "   bi      \bibitem[]{}                  clsr    \columnseprule               "
    "   bbgs    \bibliographystyle{}          clw     \columnwidth                 "
    "   bbgst   \bibliographystyle{}          cprg    \copyright                   "
    //
    "                                    D -- F                                    "
    " "
    "   dg      \dag                          fxs     \fboxsep                     "
    "   dx      \dashbox{}()[]{}              fx      \fbox{}                      "
    "   dttd    \date{\today}                 fl      \fill                        "
    "   dt      \date{}                       flpf    \floatpagefraction           "
    "   dd      \day                          fls     \floatsep                    "
    "   2flpf   \dblfloatpagefraction         fbt     \flushbottom                 "
    "   2fls    \dblfloatsep                  fnsb    \fnsymbol{}                  "
    "   2txfls  \dbltextfloatsep              fh      \footheight                  "
    "   2tf     \dbltopfraction               fnm     \footnotemark[]              "
    "   dpst    \displaystyle                 fnr     \footnoterule                "
    "   ds      \documentstyle[a4]{}          fns     \footnotesep                 "
    "   dst     \documentstyle[a4]{}          fnz     \footnotesize                "
    "   dfl     \dotfill                      fntx    \footnotetext[]{}            "
    "   2r      \doublerulesep                fn      \footnote[]{}                "
    "   ec      \encl{}                       fsk     \footskip                    "
    "   ei      \endinput                     frx     \framebox()[]{}              "
    "   ed      \end{}                        fr      \frame{}                     "
    "   esm     \evensidemargin               fp      \frenchspacing               "
    "   fxr     \fboxrule                     fss     \fussy                       "
    //
    "                                    G -- L                                    "
    " "
    "   gle     \glossaryentry{}{}            im      \item[]                      "
    "   gl      \glossary{}                   kl      \kill                        "
    "   hdh     \headheigth                   lbs     \labelsep                    "
    "   hds     \headsep                      lbw     \labelwidth                  "
    "   hfl     \hfill                        lb      \label{}                     "
    "   hl      \hline                        LG      \LARGE                       "
    "   hrfl    \hrulefill                    Lg      \Large                       "
    "   hs      \hspace*{}                    lg      \large                       "
    "   hg      \huge                         lds     \ldots                       "
    "   hp      \hyphenation{}                lteq    \lefteqn{}                   "
    "   ico     \includeonly{}                ltm     \leftmargin                  "
    "   ic      \include{}                    ln      \line(){}                    "
    "   ixe     \indexentry{}{}               lnb     \linebreak[]                 "
    "   ixs     \indexspace                   lntc    \linethickness{}             "
    "   ix      \index{}                      lnw     \linewidth                   "
    "   ip      \input{}                      lof     \listoffigures               "
    "   itxs    \intextsep                    lot     \listoftables                "
    "   imi     \itemindent                   lpi     \listparindent               "
    "   ims     \itemsep                      ld      \load{}{}                    "
    //
    "                                    M -- O                                    "
    " "
    "   mkx     \makebox()[]{}                ne      \newenvironment{}[]{}{}      "
    "   mkgl    \makeglossary                 nf      \newfont{}{}                 "
    "   mki     \makeindex                    nlg     \newlength{}                 "
    "   mktt    \maketitle                    nl      \newline                     "
    "   mkttl   \maketitle                    np      \newpage                     "
    "   mpph    \marginparpush                nsx     \newsavebox{}                "
    "   mps     \marginparsep                 nthm    \newtheorem{}[]{}[]          "
    "   mpw     \marginparwidth               noc     \nocite{}                    "
    "   mp      \marginpar[]{}                nof     \nofiles                     "
    "   mkb     \markboth{}{}                 noi     \noindent                    "
    "   mkrg    \markright{}                  nolb    \nolinebreak[]               "
    "   mx      \mbox{}                       non     \nonumber                    "
    "   msk     \medskip                      nopb    \nopagebreak[]               "
    "   mska    \medskipamount                nmp     \normalmarginpar             "
    "   mm      \month                        nz      \normalsize                  "
    "   mcl     \multicolumn{}{}{}            oc      \obeycr                      "
    "   mpu     \multiput()(){}{}             osm     \oddsidemargin               "
    "   nc      \newcommand{}[]{}             1cl     \onecolumn                   "
    "   ncr     \newcounter{}[]               op      \opening{}                   "
    //
    "                                    P -- Sc                                   "
    " "
    "   pb      \pagebreak[]                  rglt    \raggedleft                  "
    "   pn      \pagenumbering{}              rgrg    \raggedright                 "
    "   pr      \pageref{}                    rx      \raisebox{}[][]{}            "
    "   ps      \pagestyle{}                  rf      \ref{}                       "
    "   pst     \pagestyle{}                  rnc     \renewcommand{}[]{}          "
    "   pg      \paragraph*[]{}               rne     \renewenvironment{}[]{}{}    "
    "   px      \parbox[]{}{}                 rc      \restorecr                   "
    "   pi      \parindent                    rmp     \reversemarginpar            "
    "   psp     \parsep                       rgm     \rightmargin                 "
    "   psk     \parskip                      Rmn     \Roman                       "
    "   prt     \part*[]{}                    rmn     \roman                       "
    "   pts     \partopsep                    rl      \rule[]{}{}                  "
    "   ppt     \poptabs                      sp      \samepage                    "
    "   pds     \pounds                       svx     \savebox{}()[]{}             "
    "   pfx     \prefixing                    sx      \sbox{}                      "
    "   ptc     \protect                      ssst    \scriptscriptstyle           "
    "   pht     \pushtabs                     sz      \scriptsize                  "
    "   pt      \put(){}                      sst     \scriptstyle                 "
    "   rbt     \raggedbottom                                                      "
    //
    "                                    Sd -- T                                   "
    " "
    "   sn      \section*[]{}                 txf     \textfraction                "
    "   tx      \setbox{}                     txh     \textheight                  "
    "   tcr     \setcounter{}{}               txst    \textstyle                   "
    "   tlg     \setlength{}{}                txw     \textwidth                   "
    "   ttw     \settowidth{}{}               tks     \thanks{}                    "
    "   shst    \shortstack[]{}               tcl     \thicklines                  "
    "   sg      \signature{}                  tnl     \thinlines                   "
    "   slp     \sloppy                       tns     \thinspace                   "
    "   sm      \small                        tps     \thispagestyle{}             "
    "   ssk     \smallskip                    tpst    \thispagestyle{}             "
    "   sska    \smallskipamount              tn      \tiny                        "
    "   st      \stretch{}                    ttl     \title{}                     "
    "   up      \subparagraph*[]{}            tf      \topfraction                 "
    "   usn     \subsection*[]{}              tm      \topmargin                   "
    "   sb      \symbol{}                     ts      \topsep                      "
    "   tgs     \tabbingsep                   tsk     \topskip                     "
    "   tcs     \tabcolsep                    2cl     \twocolumn[]                 "
    "   toc     \tableofcontents              ti      \typein[]{}                  "
    "   txfls   \textfloatsep                 to      \typeout{}                   "
    //
    "                                    U -- Z                                    "
    " "
    "   ubmh    \unboldmath                   vc      \vector(){}                  "
    "   udl     \underline{}                  vb      \verb**                      "
    "   ulg     \unitlength                   vfl     \vfill                       "
    "   ux      \usebox{}                     vl      \vline                       "
    "   ucr     \usecounter{}                 vs      \vspace*{}                   "
    "   val     \value{}                      yy      \year                        "
    " "
    "   bf      {\bf }                        sc      {\sc }                       "
    "   em      {\em \/}                      sf      {\sf }                       "
    "   it      {\it \/}                      sl      {\sl }                       "
    "   rm      {\rm }                        tt      {\tt }                       "
    " "
    "   emtex   em\TeX                                                             "
    "   ltx     \LaTeX                                                             "
    "   ltx2e   \LaTeX\,2\raisebox{-.33ex}{$\varepsilon$}                          "
    "   tex     \TeX                                                               "
    " "
    "   ck      Cezary M. Kruk                                                     "
    "   home    ul. Zielonogorska 7 m. 2, 53-617 Wroclaw, (0-71) 55 67 94          "
    " "
    end

<`> LaTeX()

<Alt `> Alias()

<Alt h> QuickHelp(LaTeXHelp)

